Cars/config/routes.rb
Rails.application.routes.draw do
  resources :cars
  #get 'car/index'
  root 'cars#index'

  devise_for :users
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

Cars/app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

Cars/app/models/car.rb
class Car < ApplicationRecord
end

Cars/app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
end

Cars/app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
  before_action :authenticate_user!
end

Cars/app/controllers/cars_controller.rb
class CarsController < ApplicationController
  before_action :set_car, only: [:show, :edit, :update, :destroy]
  before_action :is_admin, except: [:show, :index]

  # GET /cars
  # GET /cars.json

  def is_admin
    redirect_to root_path unless current_user.admin?
  end

  def index
    @cars = Car.all
  end

  # GET /cars/1
  # GET /cars/1.json
  def show

  end

  # GET /cars/new
  def new
    @car = Car.new
  end

  # GET /cars/1/edit
  def edit
  end

  # POST /cars
  # POST /cars.json
  def create
    @car = Car.new(car_params)

    respond_to do |format|
      if @car.save
        format.html { redirect_to @car, notice: 'Car was successfully created.' }
        format.json { render :show, status: :created, location: @car }
      else
        format.html { render :new }
        format.json { render json: @car.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /cars/1
  # PATCH/PUT /cars/1.json
  def update
    respond_to do |format|
      if @car.update(car_params)
        format.html { redirect_to @car, notice: 'Car was successfully updated.' }
        format.json { render :show, status: :ok, location: @car }
      else
        format.html { render :edit }
        format.json { render json: @car.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /cars/1
  # DELETE /cars/1.json
  def destroy
    @car.destroy
    respond_to do |format|
      format.html { redirect_to cars_url, notice: 'Car was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_car
      @car = Car.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def car_params
      params.require(:car).permit(:model, :color, :price, :year, :details)
    end
end

Cars/app/controllers/welcome_controller.rb
class WelcomeController < ApplicationController
  def index
  end
end

Cars/app/helpers/application_helper.rb
module ApplicationHelper
end

Cars/app/helpers/cars_helper.rb
module CarsHelper
end

Cars/app/helpers/welcome_helper.rb
module WelcomeHelper
end

Cars/app/views/cars/_form.html.erb
<%= form_with(model: car, local: true) do |form| %>
  <% if car.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(car.errors.count, "error") %> prohibited this car from being saved:</h2>

      <ul>
      <% car.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :model %>
    <%= form.text_field :model, id: :car_model %>
  </div>

  <div class="field">
    <%= form.label :color %>
    <%= form.text_field :color, id: :car_color %>
  </div>

  <div class="field">
    <%= form.label :price %>
    <%= form.text_field :price, id: :car_price %>
  </div>

  <div class="field">
    <%= form.label :year %>
    <%= form.number_field :year, id: :car_year %>
  </div>

  <div class="field">
    <%= form.label :details %>
    <%= form.text_area :details, id: :car_details %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

Cars/app/views/cars/edit.html.erb
<h1>Editing Car</h1>

<%= render 'form', car: @car %>

<%= link_to 'Show', @car %> |
<%= link_to 'Back', cars_path %>

Cars/app/views/cars/index.html.erb
<p id="notice"><%= notice %></p>

<h1><strong>CARS FOR SALE</strong></h1>


  <style>
table {
    font-family: arial, sans-serif;
    border-collapse: collapse;
    width: 80%;
}

td, th {
    border: 1px solid #dddddd;
    text-align: left;
    padding: 8px;
}

tr:nth-child(even) {
    background-color: #dddddd;
}
</style>

<table>
  <thead>
    <tr>
      <th>Model</th>
      <th>Color</th>
      <th>Price</th>
      <th>Year</th>
      <th>Details</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @cars.each do |car| %>
      <tr>
        <td><%= car.model %></td>
        <td><%= car.color %></td>
        <td><%= car.price %></td>
        <td><%= car.year %></td>
        <td><%= car.details %></td>
        <td><%= link_to 'Show', car %></td>
        <% if current_user.admin?%>
        <td><%= link_to 'Edit', edit_car_path(car) %></td>
        <td><%= link_to 'Destroy', car, method: :delete, data: { confirm: 'Are you sure?' } %></td>
        <% end %>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<% if current_user.admin?%>
<%= link_to 'New Car', new_car_path %>
<% end %>

Cars/app/views/cars/new.html.erb
<h1>New Car</h1>

<%= render 'form', car: @car %>

<%= link_to 'Back', cars_path %>

Cars/app/views/cars/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Model:</strong>
  <%= @car.model %>
</p>

<p>
  <strong>Color:</strong>
  <%= @car.color %>
</p>

<p>
  <strong>Price:</strong>
  <%= @car.price %>
</p>

<p>
  <strong>Year:</strong>
  <%= @car.year %>
</p>

<p>
  <strong>Details:</strong>
  <%= @car.details %>
</p>

<%= link_to 'Edit', edit_car_path(@car) if current_user.admin? %> |
<%= link_to 'Back', cars_path %>

Cars/app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Cars</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body background="http://oi67.tinypic.com/2n22zwl.jpg">

  	<p class="navbar-text pull-right">
	<% if user_signed_in? %>
      <br />
      <br />
      <br />
  	Logged in as <strong><%= current_user.email %></strong>.
  	<%= link_to 'Edit profile', edit_user_registration_path, :class => 'navbar-link' %> |
  	<%= link_to "Logout", destroy_user_session_path, method: :delete, :class => 'navbar-link'  %>
	<% else %>
    <br />
    <br />
    <br />
  	<%= link_to "Sign up", new_user_registration_path, :class => 'navbar-link'  %> |
  	<%= link_to "Login", new_user_session_path, :class => 'navbar-link'  %>
	<% end %>
	</p>
  	<% if notice %>
  	<p class="alert alert-success"><%= notice %></p>
	<% end %>
	<% if alert %>
  	<p class="alert alert-danger"><%= alert %></p>
	<% end %>
    <%= yield %>
  </body>
</html>

Cars/app/views/welcome/index.html.erb
<h1>Welcome#index</h1>
<p>Find me in app/views/welcome/index.html.erb</p>